Bug 1468837 - glibc: bash no longer has job control under systemd-nspawn (via mock)
glibc: bash no longer has job control under systemd-nspawn (via mock)
Status: MODIFIED
Product: Fedora
Classification: Fedora
Component: glibc (Show other bugs)
27
x86_64 Linux
unspecified Severity medium
: ---
: ---
Assigned To: Florian Weimer
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-08 13:42 EDT by Jerry James
Modified: 2017-12-15 05:50 EST (History)
18 users (show)

See Also:
Fixed In Version: glibc-2.26.9000-27.fc28
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jerry James 2017-07-08 13:42:57 EDT
Description of problem:

$ mock -r fedora-rawhide-x86_64 --shell
INFO: mock.py version 1.4.2 starting (python version = 3.5.3)...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled HW Info plugin
Finish: chroot init
Start: shell
sh: cannot set terminal process group (-1): Inappropriate ioctl for device
sh: no job control in this shell
<mock-chroot> sh-4.4# su - mockbuild
-bash: cannot set terminal process group (2): Inappropriate ioctl for device
-bash: no job control in this shell

Version-Release number of selected component (if applicable):
mock-1.4.2-1.fc25.noarch

How reproducible:
Always

Steps to Reproduce:
1. mock -r <architecture> shell
2.
3.

Actual results:
A shell with no job control.

Expected results:
A shell with job control.

Additional info:
This used to work in the previous version, mock-1.3.4-1.fc25.
Comment 1 Miroslav Suchý 2017-07-10 08:46:04 EDT
This is because all commands in chroot are now executed using systemd-nspawn, which uses busybox. See:
https://busybox.net/FAQ.html#job_control

If you want old behaviour you can use --old-chroot

I will keep this open, but I am not treating this as bug, but more like RFE.
Comment 2 Fedora End Of Life 2017-11-16 14:20:25 EST
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 3 Florian Weimer 2017-12-13 08:20:07 EST
Isn't this a glibc bug, namely:

  https://sourceware.org/bugzilla/show_bug.cgi?id=22145

Could you check current rawhide and see if it is fixed?  Note that the glibc version inside the chroot matters.  The first version with the upstream fix is glibc-2.26.9000-27.fc28.
Comment 4 Miroslav Suchý 2017-12-15 05:42:36 EST
Indeed. It is working now in rawhide. Thank you for the investigation Florian.

I will not close this as duplicate as this is worth mentioning in relase notes and errata.
Comment 5 Florian Weimer 2017-12-15 05:49:09 EST
I'll see if I can backport the glibc fix into Fedora 27.

Note You need to log in before you can comment on or make changes to this bug.